/*
 * #%L
 * *********************************************************************************************************************
 * 
 * These Foolish Things - Miscellaneous utilities
 * http://thesefoolishthings.java.net - hg clone https://bitbucket.org/tidalwave/thesefoolishthings-src
 * %%
 * Copyright (C) 2009 - 2013 Tidalwave s.a.s. (http://tidalwave.it)
 * %%
 * *********************************************************************************************************************
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * *********************************************************************************************************************
 * 
 * $Id: AsExtensions.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 * 
 * *********************************************************************************************************************
 * #L%
 */
package it.tidalwave.util.asexamples;

import it.tidalwave.util.As;
import javax.annotation.Nonnull;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: AsExtensions.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 *
 **********************************************************************************************************************/
public class AsExtensions
  {
    public static <T> T as (final @Nonnull Object datum,
                            final @Nonnull Class<T> roleClass)
      {
        return as(datum, roleClass, As.Defaults.throwAsException(roleClass));
      }

    public static <T> T as (final @Nonnull Object datum,
                            final @Nonnull Class<T> roleClass,
                            final @Nonnull As.NotFoundBehaviour<T> notFoundBehaviour)
      {
        try
          {
            final Class<? extends Object> datumClass = datum.getClass();
            final String roleClassName = "it.tidalwave.util.asexamples."
                    + datumClass.getSimpleName() + roleClass.getSimpleName() + "Role";
            return (T)Class.forName(roleClassName).getConstructor(datumClass).newInstance(datum);
          }
        catch (Exception e)
          {
            return notFoundBehaviour.run(e);
          }
      }
  }
