/*
 * #%L
 * *********************************************************************************************************************
 * 
 * These Foolish Things - Miscellaneous utilities
 * http://thesefoolishthings.java.net - hg clone https://bitbucket.org/tidalwave/thesefoolishthings-src
 * %%
 * Copyright (C) 2009 - 2013 Tidalwave s.a.s. (http://tidalwave.it)
 * %%
 * *********************************************************************************************************************
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 * 
 * *********************************************************************************************************************
 * 
 * $Id: UserNotificationWithFeedbackMatcher.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 * 
 * *********************************************************************************************************************
 * #L%
 */
package it.tidalwave.util.ui;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;
import java.util.regex.Pattern;
import org.hamcrest.BaseMatcher;
import org.hamcrest.Description;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: UserNotificationWithFeedbackMatcher.java,v e7e97a14be7c 2013/02/16 19:44:07 fabrizio $
 *
 **********************************************************************************************************************/
// FIXME: merge with the one in blueBill Core
public class UserNotificationWithFeedbackMatcher extends BaseMatcher<UserNotificationWithFeedback>
  {
    private static final Logger log = LoggerFactory.getLogger(UserNotificationWithFeedbackMatcher.class);

    @Nonnull
    private final String caption;

    @Nonnull
    private final String text;

    private String d = "UserNotificationWithFeedback ?";

    private UserNotificationWithFeedback notification;

    /*******************************************************************************************************************
     *
     *
     *
     ******************************************************************************************************************/
    /* package */ UserNotificationWithFeedbackMatcher (final @Nonnull String caption, final @Nonnull String text)
      {
        this.caption = caption;
        this.text = text;
        this.d = String.format("UserNotificationWithFeedback[text=%s, caption=%s]", text, caption);
      }

    /*******************************************************************************************************************
     *
     * {@inheritDoc}
     *
     ******************************************************************************************************************/
    public boolean matches (final @Nullable Object item)
      {
        if (!(item instanceof UserNotificationWithFeedback))
          {
            return false;
          }

        notification = (UserNotificationWithFeedback)item;

        final boolean b = Pattern.matches(caption, notification.getCaption())
                       && Pattern.matches(text, notification.getText());

        if (!b)
          {
            d = String.format("%s (instead is %s)", d, item);
          }

        return b;
      }

    /*******************************************************************************************************************
     *
     * {@inheritDoc}
     *
     ******************************************************************************************************************/
    public void describeTo (final @Nonnull Description description)
      {
        description.appendText(d);
      }
  }
